/*
 * Internal Includes
 */
#include <Application.hpp>
#include <iostream>

Application::Application() {
}

Application::~Application() {
	delete net;
	delete mainwindow;
	delete qtapplication;
}


int Application::execute(int argc, char **argv) {
    long long int r=0;
    
	
	/*
	 * Command line arguments processing
	 */
    while (-1 != (r = getopt(argc,argv,"h"))) {
        switch (r) {
        case 'h' :
            print_help();
            exit(EXIT_SUCCESS);
            break;
		}
		
	}
	
	if (argc < 3) {
		print_help();
        exit(EXIT_FAILURE);
	}
	/*
	 * Launching QtApplication
     */
    qtapplication = new QApplication(argc,argv);    

	
	/*
	 * Main window initialisation
	 */
	mainwindow = new MainWindow();
	mainwindow->getQMainWindow().show();

	net = new NetworkManager (argv[1],atoi(argv[2]),getMainWindow().lineEdit,getMainWindow().textBrowser);
	net->start();

	/* Connection de la touche Entrée au NetworkManager */
	QObject::connect(getMainWindow().lineEdit,SIGNAL(returnPressed()),net,SLOT(sendLine()));
	
	return qtapplication->exec();
}

void Application::print_help() {
    std::cout << "exo3 [-h] <hostname> <port>  \n\t " << std::endl;
}
